// Qt Headers

#include <qapplication.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qevent.h>
#include <qmenubar.h>

// Local Headers

#include "QALE.h"
#include "example2.h"

// Embedded layout information

static char *dialogLayout =
   "example2(600, 100, 0, 0, LT)"
   "{"
   "   define {"
   "      percentage = .8"
   "      remainder  = (1 - $percentage) / 2"
   "      theWidth   = $percentage * w"
   "      theHeight  = $percentage * h"
   "      xLocation  = $remainder  * w"
   "      yLocation  = $remainder  * h"
   "   }"
   ""
   "   groupBox($theWidth, $theHeight, $xLocation, $yLocation, LT)"
   "   {"
   "      define"
   "      {"
   "         step       = w / 4"
   "         horizontal = h / 8"
   "      }"
   ""
   "      button1(dw, dh, $step,             5 * $horizontal, CC)"
   "      button2(dw, dh, button1.x + $step, 4 * $horizontal, CC)"
   "      button3(dw, dh, button2.x + $step, 3 * $horizontal, CC)"
   "   }"
   "}";

class MyGroupBox : public QGroupBox
{
   public:
      MyGroupBox(QWidget *parent);
};

MyGroupBox::MyGroupBox(QWidget *parent)
   : QGroupBox(parent)
{
   setObjectName("groupBox");

   QPushButton *ptr = 0;

   ptr = new QPushButton("First Button", this);
   ptr->setObjectName("button1");

   ptr = new QPushButton("Second Button", this);
   ptr->setObjectName("button2");

   ptr = new QPushButton("Third Button", this);
   ptr->setObjectName("button3");
}

Example2::Example2() : QMainWindow()
{
   setObjectName("example2");

   (void)new MyGroupBox(this);

   mQALE = QALE::constructFromText(this, dialogLayout);
}

Example2::~Example2()
{
   delete mQALE;
}

void Example2::resizeEvent(QResizeEvent *)
{
   mQALE->process();
}

double Example2::doit() const
{
   return(200.0);
}

int main(int argc, char **argv)
{
   QApplication theApplication(argc, argv);

   theApplication.connect(
      &theApplication,
      SIGNAL(lastWindowClosed()),
      &theApplication,
      SLOT(quit())
   );

   Example2 exampleOne;
   exampleOne.show();

   return(theApplication.exec());
}
