/*****************************************************************************
 * BinaryNode.h
 *****************************************************************************/

#ifndef _BINARY_NODE_H_
#   define _BINARY_NODE_H_

#include "Node.h"

class BinaryNode : public Node
{
   public:
      typedef enum { _PLUS_, _MINUS_, _TIMES_, _DIVIDE_ } Operator;

      BinaryNode(
         const Node *left,
         Operator theOperator,
         const Node *right
      );

      ~BinaryNode();

      double evaluate() const;

      ostream &print(ostream &out) const;

      Node *copy() const;

      void accept(Visitor &) const;

   private:
      BinaryNode(const BinaryNode &other);
      BinaryNode &operator=(const BinaryNode &other);
      const char *operatorAsString() const;

      const Node *mLeft;
      const Operator mOperator;
      const Node *mRight;
};
#endif
