#ifndef _POINTER_SET_H_
#   define _POINTER_SET_H_

typedef void (*DeleteFunction)(void *);

class PointerSet
{
   public:
      PointerSet(DeleteFunction deleteFunction);
      ~PointerSet();
      void add(void *);
      void *remove(void *);
      static int main(int argc, char **argv);
      void print() const;

      static void genericDelete(void *);
      static void genericArrayDelete(void *);

   private:
      PointerSet(const PointerSet &);
      PointerSet &operator=(const PointerSet &);

      static int hashCode(void *);

      enum { SIZE = 256 };

      struct Entry;
      Entry **mEntries;
      DeleteFunction mDeleteFunction;
};

#endif
