#ifndef _QALE_H_
#   define _QALE_H_

class MessageReceiver;
class Widget;
class QWidget;
class StringMap;

class QALE
{
   private:
      QALE(
         QWidget *root,
         Widget *theWidget,
         MessageReceiver *receiver
      );

      QALE();

      QALE(const QALE &);
      QALE &operator=(const QALE &);

      Widget *mWidget;
      int mStillborn;

#ifdef __GNUC__
      friend class PacifyGPlusPlus;
#endif

   public:
      ~QALE();

      void process() const;

      static QALE *constructFromFile(
         QWidget *root,
         const char *fileName,
         MessageReceiver *receiver = 0
      );

      static QALE *constructFromText(
         QWidget *root,
         const char *text,
         MessageReceiver *receiver = 0
      );
};

#endif
